=== modified file 'drizzled/set_var.cc'
--- drizzled/set_var.cc	2009-03-10 02:09:55 +0000
+++ drizzled/set_var.cc	2009-03-11 01:16:44 +0000
@@ -109,7 +109,8 @@
 static void fix_trans_mem_root(Session *session, enum_var_type type);
 static void fix_server_id(Session *session, enum_var_type type);
 static uint64_t fix_unsigned(Session *, uint64_t, const struct my_option *);
-static bool get_unsigned(Session *session, set_var *var);
+static bool get_unsigned32(Session *session, set_var *var);
+static bool get_unsigned64(Session *session, set_var *var);
 bool throw_bounds_warning(Session *session, bool fixed, bool unsignd,
                           const char *name, int64_t val);
 static KEY_CACHE *create_key_cache(const char *name, uint32_t length);
@@ -183,7 +184,7 @@
                                          &opt_local_infile);
 static sys_var_session_uint32_t	sys_max_allowed_packet(&vars, "max_allowed_packet",
                                                        &SV::max_allowed_packet);
-static sys_var_long_ptr	sys_max_connect_errors(&vars, "max_connect_errors",
+static sys_var_uint64_t_ptr	sys_max_connect_errors(&vars, "max_connect_errors",
                                                &max_connect_errors);
 static sys_var_session_uint64_t	sys_max_error_count(&vars, "max_error_count",
                                                   &SV::max_error_count);
@@ -204,7 +205,7 @@
                                                     &SV::max_sort_length);
 static sys_var_session_uint64_t	sys_max_tmp_tables(&vars, "max_tmp_tables",
                                                    &SV::max_tmp_tables);
-static sys_var_long_ptr	sys_max_write_lock_count(&vars, "max_write_lock_count",
+static sys_var_uint64_t_ptr	sys_max_write_lock_count(&vars, "max_write_lock_count",
                                                  &max_write_lock_count);
 static sys_var_session_uint64_t sys_min_examined_row_limit(&vars, "min_examined_row_limit",
                                                            &SV::min_examined_row_limit);
@@ -274,7 +275,7 @@
 static sys_var_uint32_t_ptr  sys_server_id(&vars, "server_id", &server_id,
                                            fix_server_id);
 
-static sys_var_long_ptr	sys_slow_launch_time(&vars, "slow_launch_time",
+static sys_var_uint64_t_ptr	sys_slow_launch_time(&vars, "slow_launch_time",
                                              &slow_launch_time);
 static sys_var_session_size_t	sys_sort_buffer(&vars, "sort_buffer_size",
                                                 &SV::sortbuff_size);
@@ -291,11 +292,11 @@
 				       &SV::table_plugin);
 static sys_var_const_str	sys_system_time_zone(&vars, "system_time_zone",
                                              system_time_zone);
-static sys_var_long_ptr	sys_table_def_size(&vars, "table_definition_cache",
+static sys_var_uint64_t_ptr	sys_table_def_size(&vars, "table_definition_cache",
                                            &table_def_size);
-static sys_var_long_ptr	sys_table_cache_size(&vars, "table_open_cache",
+static sys_var_uint64_t_ptr	sys_table_cache_size(&vars, "table_open_cache",
 					     &table_cache_size);
-static sys_var_long_ptr	sys_table_lock_wait_timeout(&vars, "table_lock_wait_timeout",
+static sys_var_uint64_t_ptr	sys_table_lock_wait_timeout(&vars, "table_lock_wait_timeout",
                                                     &table_lock_wait_timeout);
 static sys_var_session_enum	sys_tx_isolation(&vars, "tx_isolation",
                                              &SV::tx_isolation,
@@ -639,7 +640,7 @@
     else
       llstr(val, buf);
 
-    push_warning_printf(session, DRIZZLE_ERROR::WARN_LEVEL_WARN,
+    push_warning_printf(session, DRIZZLE_ERROR::WARN_LEVEL_ERROR,
                         ER_TRUNCATED_WRONG_VALUE,
                         ER(ER_TRUNCATED_WRONG_VALUE), name, buf);
   }
@@ -667,14 +668,26 @@
   return out;
 }
 
-static bool get_unsigned(Session *, set_var *var)
-{
-  if (var->value->unsigned_flag)
-    var->save_result.uint64_t_value= (uint64_t) var->value->val_int();
-  else
-  {
-    int64_t v= var->value->val_int();
-    var->save_result.uint64_t_value= (uint64_t) ((v < 0) ? 0 : v);
+static bool get_unsigned32(Session *, set_var *var)
+{
+  if (var->value->unsigned_flag)
+    var->save_result.uint32_t_value= (uint32_t) var->value->val_int();
+  else
+  {
+    int64_t v= var->value->val_int();
+    var->save_result.uint32_t_value= (uint32_t) ((v < 0) ? 0 : v);
+  }
+  return 0;
+}
+
+static bool get_unsigned64(Session *, set_var *var)
+{
+  if (var->value->unsigned_flag)
+      var->save_result.uint64_t_value=(uint64_t) var->value->val_int();
+  else
+  {
+    int64_t v= var->value->val_int();
+      var->save_result.uint64_t_value= (uint64_t) ((v < 0) ? 0 : v);
   }
   return 0;
 }
@@ -691,57 +704,22 @@
   return 0;
 }
 
-
-sys_var_long_ptr::
-sys_var_long_ptr(sys_var_chain *chain, const char *name_arg, uint64_t *value_ptr_arg,
-                 sys_after_update_func after_update_arg)
-  :sys_var_long_ptr_global(chain, name_arg, value_ptr_arg,
-                           &LOCK_global_system_variables, after_update_arg)
-{}
-
-
-bool sys_var_long_ptr_global::check(Session *session, set_var *var)
-{
-  return get_unsigned(session, var);
-}
-
-bool sys_var_long_ptr_global::update(Session *session, set_var *var)
-{
-  uint64_t tmp= var->save_result.uint64_t_value;
-  pthread_mutex_lock(guard);
-  if (option_limits)
-    *value= (uint64_t) fix_unsigned(session, tmp, option_limits);
-  else
-  {
-    if (tmp > UINT32_MAX)
-    {
-      tmp= UINT32_MAX;
-      throw_bounds_warning(session, true, true, name,
-                           (int64_t) var->save_result.uint64_t_value);
-    }
-    *value= (uint64_t) tmp;
-  }
-
-  pthread_mutex_unlock(guard);
+bool sys_var_uint32_t_ptr::check(Session *, set_var *var)
+{
+  var->save_result.uint32_t_value= var->value->val_int();
   return 0;
 }
 
-
-void sys_var_long_ptr_global::set_default(Session *, enum_var_type)
-{
-  bool not_used;
-  pthread_mutex_lock(guard);
-  *value= (uint64_t) getopt_ull_limit_value((uint64_t) option_limits->def_value,
-                                         option_limits, &not_used);
-  pthread_mutex_unlock(guard);
-}
-
 bool sys_var_uint32_t_ptr::update(Session *session, set_var *var)
 {
   uint32_t tmp= var->save_result.uint32_t_value;
   pthread_mutex_lock(&LOCK_global_system_variables);
   if (option_limits)
-    *value= (uint32_t) fix_unsigned(session, tmp, option_limits);
+  {
+    uint32_t newvalue= (uint32_t) fix_unsigned(session, tmp, option_limits);
+    if(newvalue==tmp)
+      *value= newvalue;
+  }
   else
     *value= (uint32_t) tmp;
   pthread_mutex_unlock(&LOCK_global_system_variables);
@@ -764,7 +742,11 @@
   uint64_t tmp= var->save_result.uint64_t_value;
   pthread_mutex_lock(&LOCK_global_system_variables);
   if (option_limits)
-    *value= (uint64_t) fix_unsigned(session, tmp, option_limits);
+  {
+    uint64_t newvalue= (uint64_t) fix_unsigned(session, tmp, option_limits);
+    if(newvalue==tmp)
+      *value= newvalue;
+  }
   else
     *value= (uint64_t) tmp;
   pthread_mutex_unlock(&LOCK_global_system_variables);
@@ -841,13 +823,13 @@
 */
 bool sys_var_session_uint32_t::check(Session *session, set_var *var)
 {
-  return (get_unsigned(session, var) ||
+  return (get_unsigned32(session, var) ||
           (check_func && (*check_func)(session, var)));
 }
 
 bool sys_var_session_uint32_t::update(Session *session, set_var *var)
 {
-  uint64_t tmp= var->save_result.uint64_t_value;
+  uint64_t tmp= (uint64_t) var->save_result.uint32_t_value;
 
   /* Don't use bigger value than given with --maximum-variable-name=.. */
   if ((uint32_t) tmp > max_system_variables.*offset)
@@ -949,7 +931,7 @@
 
 bool sys_var_session_uint64_t::check(Session *session, set_var *var)
 {
-  return (get_unsigned(session, var) ||
+  return (get_unsigned64(session, var) ||
 	  (check_func && (*check_func)(session, var)));
 }
 

=== modified file 'drizzled/set_var.h'
--- drizzled/set_var.h	2009-02-28 17:49:22 +0000
+++ drizzled/set_var.h	2009-03-11 01:16:44 +0000
@@ -145,43 +145,6 @@
 };
 
 
-/*
-  A global-only uint64_t variable that requires its access to be
-  protected with a mutex.
-*/
-
-class sys_var_long_ptr_global: public sys_var_global
-{
-  uint64_t *value;
-public:
-  sys_var_long_ptr_global(sys_var_chain *chain, const char *name_arg,
-                          uint64_t *value_ptr_arg,
-                          pthread_mutex_t *guard_arg,
-                          sys_after_update_func after_update_arg= NULL)
-    :sys_var_global(name_arg, after_update_arg, guard_arg),
-    value(value_ptr_arg)
-  { chain_sys_var(chain); }
-  bool check(Session *session, set_var *var);
-  bool update(Session *session, set_var *var);
-  void set_default(Session *session, enum_var_type type);
-  SHOW_TYPE show_type() { return SHOW_LONG; }
-  unsigned char *value_ptr(Session *, enum_var_type, const LEX_STRING *)
-  { return (unsigned char*) value; }
-};
-
-
-/*
-  A global uint64_t variable that is protected by LOCK_global_system_variables
-*/
-
-class sys_var_long_ptr :public sys_var_long_ptr_global
-{
-public:
-  sys_var_long_ptr(sys_var_chain *chain, const char *name_arg, uint64_t *value_ptr,
-                   sys_after_update_func after_update_arg= NULL);
-};
-
-
 class sys_var_uint32_t_ptr :public sys_var
 {
   uint32_t *value;
@@ -195,6 +158,7 @@
                        sys_after_update_func func)
     :sys_var(name_arg,func), value(value_ptr_arg)
   { chain_sys_var(chain); }
+  bool check(Session *session, set_var *var);
   bool update(Session *session, set_var *var);
   void set_default(Session *session, enum_var_type type);
   SHOW_TYPE show_type() { return SHOW_LONG; }

=== modified file 'tests/r/innodb.result'
--- tests/r/innodb.result	2009-02-28 20:43:31 +0000
+++ tests/r/innodb.result	2009-03-11 01:16:44 +0000
@@ -1716,7 +1716,7 @@
 innodb_thread_concurrency	0
 set global innodb_thread_concurrency=1001;
 Warnings:
-Warning	1292	Truncated incorrect thread_concurrency value: '1001'
+Error	1292	Truncated incorrect thread_concurrency value: '1001'
 show variables like "innodb_thread_concurrency";
 Variable_name	Value
 innodb_thread_concurrency	1000
@@ -1737,7 +1737,7 @@
 innodb_concurrency_tickets	1000
 set global innodb_concurrency_tickets=0;
 Warnings:
-Warning	1292	Truncated incorrect concurrency_tickets value: '0'
+Error	1292	Truncated incorrect concurrency_tickets value: '0'
 show variables like "innodb_concurrency_tickets";
 Variable_name	Value
 innodb_concurrency_tickets	1

=== modified file 'tests/r/order_by.result'
--- tests/r/order_by.result	2009-02-21 16:00:06 +0000
+++ tests/r/order_by.result	2009-03-11 01:16:44 +0000
@@ -2302,7 +2302,7 @@
 insert into t1 values (1,2),(3,2);
 set session sort_buffer_size= 30000;
 Warnings:
-Warning	1292	Truncated incorrect sort_buffer_size value: '30000'
+Error	1292	Truncated incorrect sort_buffer_size value: '30000'
 set session max_sort_length= 2180;
 select * from t1 order by b;
 a	b

=== modified file 'tests/r/subselect.result'
--- tests/r/subselect.result	2009-02-25 16:45:57 +0000
+++ tests/r/subselect.result	2009-03-11 01:16:44 +0000
@@ -3277,7 +3277,7 @@
 PRIMARY KEY (x), FOREIGN KEY (y) REFERENCES t1 (b)) ENGINE=MyISAM;
 SET SESSION sort_buffer_size = 32 * 1024;
 Warnings:
-Warning	1292	Truncated incorrect sort_buffer_size value: '32768'
+Error	1292	Truncated incorrect sort_buffer_size value: '32768'
 SELECT COUNT(*) 
 FROM (SELECT  a, b, (SELECT x FROM t2 WHERE y=b ORDER BY z DESC LIMIT 1) c
 FROM t1) t;
@@ -3644,7 +3644,7 @@
 INSERT INTO `t2` VALUES ('asdf');
 SET session sort_buffer_size=8192;
 Warnings:
-Warning	1292	Truncated incorrect sort_buffer_size value: '8192'
+Error	1292	Truncated incorrect sort_buffer_size value: '8192'
 SELECT (SELECT 1 FROM  t1 WHERE t1.a=t2.a ORDER BY t1.b LIMIT 1) AS d1 FROM t2;
 d1
 1

=== modified file 'tests/r/subselect_no_mat.result'
--- tests/r/subselect_no_mat.result	2009-02-25 16:45:57 +0000
+++ tests/r/subselect_no_mat.result	2009-03-11 01:16:44 +0000
@@ -3281,7 +3281,7 @@
 PRIMARY KEY (x), FOREIGN KEY (y) REFERENCES t1 (b)) ENGINE=MyISAM;
 SET SESSION sort_buffer_size = 32 * 1024;
 Warnings:
-Warning	1292	Truncated incorrect sort_buffer_size value: '32768'
+Error	1292	Truncated incorrect sort_buffer_size value: '32768'
 SELECT COUNT(*) 
 FROM (SELECT  a, b, (SELECT x FROM t2 WHERE y=b ORDER BY z DESC LIMIT 1) c
 FROM t1) t;
@@ -3648,7 +3648,7 @@
 INSERT INTO `t2` VALUES ('asdf');
 SET session sort_buffer_size=8192;
 Warnings:
-Warning	1292	Truncated incorrect sort_buffer_size value: '8192'
+Error	1292	Truncated incorrect sort_buffer_size value: '8192'
 SELECT (SELECT 1 FROM  t1 WHERE t1.a=t2.a ORDER BY t1.b LIMIT 1) AS d1 FROM t2;
 d1
 1

=== modified file 'tests/r/subselect_no_mat_and_semi_join.result'
--- tests/r/subselect_no_mat_and_semi_join.result	2009-03-05 07:54:39 +0000
+++ tests/r/subselect_no_mat_and_semi_join.result	2009-03-11 01:16:44 +0000
@@ -3281,7 +3281,7 @@
 PRIMARY KEY (x), FOREIGN KEY (y) REFERENCES t1 (b)) ENGINE=MyISAM;
 SET SESSION sort_buffer_size = 32 * 1024;
 Warnings:
-Warning	1292	Truncated incorrect sort_buffer_size value: '32768'
+Error	1292	Truncated incorrect sort_buffer_size value: '32768'
 SELECT COUNT(*) 
 FROM (SELECT  a, b, (SELECT x FROM t2 WHERE y=b ORDER BY z DESC LIMIT 1) c
 FROM t1) t;
@@ -3648,7 +3648,7 @@
 INSERT INTO `t2` VALUES ('asdf');
 SET session sort_buffer_size=8192;
 Warnings:
-Warning	1292	Truncated incorrect sort_buffer_size value: '8192'
+Error	1292	Truncated incorrect sort_buffer_size value: '8192'
 SELECT (SELECT 1 FROM  t1 WHERE t1.a=t2.a ORDER BY t1.b LIMIT 1) AS d1 FROM t2;
 d1
 1

=== modified file 'tests/r/subselect_no_opts.result'
--- tests/r/subselect_no_opts.result	2009-02-25 16:45:57 +0000
+++ tests/r/subselect_no_opts.result	2009-03-11 01:16:44 +0000
@@ -3281,7 +3281,7 @@
 PRIMARY KEY (x), FOREIGN KEY (y) REFERENCES t1 (b)) ENGINE=MyISAM;
 SET SESSION sort_buffer_size = 32 * 1024;
 Warnings:
-Warning	1292	Truncated incorrect sort_buffer_size value: '32768'
+Error	1292	Truncated incorrect sort_buffer_size value: '32768'
 SELECT COUNT(*) 
 FROM (SELECT  a, b, (SELECT x FROM t2 WHERE y=b ORDER BY z DESC LIMIT 1) c
 FROM t1) t;
@@ -3648,7 +3648,7 @@
 INSERT INTO `t2` VALUES ('asdf');
 SET session sort_buffer_size=8192;
 Warnings:
-Warning	1292	Truncated incorrect sort_buffer_size value: '8192'
+Error	1292	Truncated incorrect sort_buffer_size value: '8192'
 SELECT (SELECT 1 FROM  t1 WHERE t1.a=t2.a ORDER BY t1.b LIMIT 1) AS d1 FROM t2;
 d1
 1

=== modified file 'tests/r/subselect_no_semijoin.result'
--- tests/r/subselect_no_semijoin.result	2009-02-25 16:45:57 +0000
+++ tests/r/subselect_no_semijoin.result	2009-03-11 01:16:44 +0000
@@ -3281,7 +3281,7 @@
 PRIMARY KEY (x), FOREIGN KEY (y) REFERENCES t1 (b)) ENGINE=MyISAM;
 SET SESSION sort_buffer_size = 32 * 1024;
 Warnings:
-Warning	1292	Truncated incorrect sort_buffer_size value: '32768'
+Error	1292	Truncated incorrect sort_buffer_size value: '32768'
 SELECT COUNT(*) 
 FROM (SELECT  a, b, (SELECT x FROM t2 WHERE y=b ORDER BY z DESC LIMIT 1) c
 FROM t1) t;
@@ -3648,7 +3648,7 @@
 INSERT INTO `t2` VALUES ('asdf');
 SET session sort_buffer_size=8192;
 Warnings:
-Warning	1292	Truncated incorrect sort_buffer_size value: '8192'
+Error	1292	Truncated incorrect sort_buffer_size value: '8192'
 SELECT (SELECT 1 FROM  t1 WHERE t1.a=t2.a ORDER BY t1.b LIMIT 1) AS d1 FROM t2;
 d1
 1

=== modified file 'tests/r/subselect_sj2.result'
--- tests/r/subselect_sj2.result	2009-01-08 23:25:12 +0000
+++ tests/r/subselect_sj2.result	2009-03-11 01:16:44 +0000
@@ -109,7 +109,7 @@
 set @save_join_buffer_size = @@join_buffer_size;
 set join_buffer_size=8000;
 Warnings:
-Warning	1292	Truncated incorrect join_buffer_size value: '8000'
+Error	1292	Truncated incorrect join_buffer_size value: '8000'
 create table t1 (a int, filler1 varbinary(20), filler2 varbinary(20));
 insert into t1 select a, 'filler123456', 'filler123456' from t0;
 insert into t1 select a+10, 'filler123456', 'filler123456' from t0;

=== modified file 'tests/r/variables.result'
--- tests/r/variables.result	2009-02-28 20:43:31 +0000
+++ tests/r/variables.result	2009-03-11 01:16:44 +0000
@@ -239,7 +239,7 @@
 NET_WRITE_TIMEOUT	500
 set net_buffer_length=1;
 Warnings:
-Warning	1292	Truncated incorrect net_buffer_length value: '1'
+Error	1292	Truncated incorrect net_buffer_length value: '1'
 show variables like 'net_buffer_length';
 Variable_name	Value
 net_buffer_length	1024
@@ -248,7 +248,7 @@
 NET_BUFFER_LENGTH	1024
 set net_buffer_length=2000000000;
 Warnings:
-Warning	1292	Truncated incorrect net_buffer_length value: '2000000000'
+Error	1292	Truncated incorrect net_buffer_length value: '2000000000'
 show variables like 'net_buffer_length';
 Variable_name	Value
 net_buffer_length	1048576
@@ -353,37 +353,37 @@
 set interactive_timeout=100;
 set join_buffer_size=100;
 Warnings:
-Warning	1292	Truncated incorrect join_buffer_size value: '100'
+Error	1292	Truncated incorrect join_buffer_size value: '100'
 set last_insert_id=1;
 set global local_infile=1;
 set max_allowed_packet=100;
 Warnings:
-Warning	1292	Truncated incorrect max_allowed_packet value: '100'
+Error	1292	Truncated incorrect max_allowed_packet value: '100'
 set global max_connect_errors=100;
 set max_heap_table_size=100;
 Warnings:
-Warning	1292	Truncated incorrect max_heap_table_size value: '100'
+Error	1292	Truncated incorrect max_heap_table_size value: '100'
 set max_join_size=100;
 set max_sort_length=100;
 set max_tmp_tables=100;
 set global max_write_lock_count=100;
 set global myisam_sort_buffer_size=100;
 Warnings:
-Warning	1292	Truncated incorrect sort_buffer_size value: '100'
+Error	1292	Truncated incorrect sort_buffer_size value: '100'
 set net_buffer_length=100;
 Warnings:
-Warning	1292	Truncated incorrect net_buffer_length value: '100'
+Error	1292	Truncated incorrect net_buffer_length value: '100'
 set net_read_timeout=100;
 set net_write_timeout=100;
 set read_buffer_size=100;
 Warnings:
-Warning	1292	Truncated incorrect read_buffer_size value: '100'
+Error	1292	Truncated incorrect read_buffer_size value: '100'
 set read_rnd_buffer_size=100;
 set global server_id=100;
 set global slow_launch_time=100;
 set sort_buffer_size=100;
 Warnings:
-Warning	1292	Truncated incorrect sort_buffer_size value: '100'
+Error	1292	Truncated incorrect sort_buffer_size value: '100'
 set sql_big_selects=1;
 set sql_buffer_result=1;
 set sql_safe_updates=1;
@@ -395,7 +395,7 @@
 set timestamp=1, timestamp=default;
 set tmp_table_size=100;
 Warnings:
-Warning	1292	Truncated incorrect tmp_table_size value: '100'
+Error	1292	Truncated incorrect tmp_table_size value: '100'
 set tx_isolation="READ-COMMITTED";
 set wait_timeout=100;
 create table t1 (a int not null auto_increment, primary key(a));
@@ -475,10 +475,10 @@
 drop table t1;
 SET GLOBAL table_open_cache=-1;
 Warnings:
-Warning	1292	Truncated incorrect table_open_cache value: '0'
+Error	1292	Truncated incorrect table_open_cache value: '18446744073709551615'
 SHOW VARIABLES LIKE 'table_open_cache';
 Variable_name	Value
-table_open_cache	1
+table_open_cache	100
 SET GLOBAL table_open_cache=DEFAULT;
 *** Various tests with LC_TIME_NAMES
 *** LC_TIME_NAMES: testing case insensitivity

